import { Readable } from 'stream';
export interface IRecord {
    createdDate: any;
    modifiedDate: any;
    state: string;
    deleted: boolean;
}
export interface IMeta {
    name: string;
    size: number;
    mimeType: string;
}
export interface IS3 {
    bucket: string;
    etag: string;
    key: string;
    secret: string;
}
export interface ICommit {
    value: boolean;
    date: any;
}
export declare class FileInfo {
    id: string;
    record: IRecord;
    meta: IMeta;
    s3: IS3;
    commit: ICommit;
}
export interface IFileRequest {
    file: Readable;
    mimeType: string;
    fileName: string;
    size?: number;
}
