"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileEmbeddedSchema = exports.S3FileSchema = exports.FileRecordSchema = exports.FileStateSchema = exports.FileMetaSchema = exports.FileLogSchema = exports.LogInitiatorSchema = exports.S3Schema = exports.FileEmbedded = exports.S3File = exports.FileRecord = exports.FileState = exports.FileMeta = exports.FileLog = exports.LogInitiator = exports.S3 = void 0;
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const s3_enum_1 = require("../../enums/s3.enum");
let S3 = class S3 {
};
exports.S3 = S3;
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: true }),
    __metadata("design:type", String)
], S3.prototype, "key", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: true }),
    __metadata("design:type", String)
], S3.prototype, "bucket", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: false }),
    __metadata("design:type", String)
], S3.prototype, "etag", void 0);
exports.S3 = S3 = __decorate([
    (0, mongoose_1.Schema)({ _id: false })
], S3);
let LogInitiator = class LogInitiator {
};
exports.LogInitiator = LogInitiator;
__decorate([
    (0, mongoose_1.Prop)({ type: String, enum: s3_enum_1.FileLogInitType, required: false }),
    __metadata("design:type", String)
], LogInitiator.prototype, "type", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: false }),
    __metadata("design:type", String)
], LogInitiator.prototype, "name", void 0);
exports.LogInitiator = LogInitiator = __decorate([
    (0, mongoose_1.Schema)({ _id: false })
], LogInitiator);
let FileLog = class FileLog {
};
exports.FileLog = FileLog;
__decorate([
    (0, mongoose_1.Prop)({ type: Date, required: true }),
    __metadata("design:type", Date)
], FileLog.prototype, "createdAt", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, enum: s3_enum_1.S3FileState, required: true }),
    __metadata("design:type", String)
], FileLog.prototype, "value", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: LogInitiator, required: false }),
    __metadata("design:type", LogInitiator)
], FileLog.prototype, "initiator", void 0);
exports.FileLog = FileLog = __decorate([
    (0, mongoose_1.Schema)()
], FileLog);
let FileMeta = class FileMeta {
};
exports.FileMeta = FileMeta;
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: false }),
    __metadata("design:type", String)
], FileMeta.prototype, "name", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: Number, required: true }),
    __metadata("design:type", Number)
], FileMeta.prototype, "size", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: true }),
    __metadata("design:type", String)
], FileMeta.prototype, "mimeType", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: true }),
    __metadata("design:type", String)
], FileMeta.prototype, "extension", void 0);
exports.FileMeta = FileMeta = __decorate([
    (0, mongoose_1.Schema)({ _id: false })
], FileMeta);
let FileState = class FileState {
};
exports.FileState = FileState;
__decorate([
    (0, mongoose_1.Prop)({ type: String, enum: s3_enum_1.S3FileState, required: true }),
    __metadata("design:type", String)
], FileState.prototype, "value", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: [FileLog], required: true, default: [] }),
    __metadata("design:type", Array)
], FileState.prototype, "log", void 0);
exports.FileState = FileState = __decorate([
    (0, mongoose_1.Schema)({ _id: false })
], FileState);
let FileRecord = class FileRecord {
};
exports.FileRecord = FileRecord;
__decorate([
    (0, mongoose_1.Prop)({ type: Date, required: true }),
    __metadata("design:type", Date)
], FileRecord.prototype, "createdAt", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: Date, required: false }),
    __metadata("design:type", Date)
], FileRecord.prototype, "updatedAt", void 0);
exports.FileRecord = FileRecord = __decorate([
    (0, mongoose_1.Schema)({ _id: false })
], FileRecord);
let S3File = class S3File {
};
exports.S3File = S3File;
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.SchemaTypes.ObjectId, required: true }),
    __metadata("design:type", mongoose_2.mongo.ObjectId)
], S3File.prototype, "id", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: FileMeta, required: true, default: null }),
    __metadata("design:type", FileMeta)
], S3File.prototype, "fileMeta", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: FileState, required: true, default: null }),
    __metadata("design:type", FileState)
], S3File.prototype, "state", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: S3, required: true, default: null }),
    __metadata("design:type", S3)
], S3File.prototype, "s3", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: FileRecord, required: true }),
    __metadata("design:type", FileRecord)
], S3File.prototype, "record", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: true }),
    __metadata("design:type", String)
], S3File.prototype, "owner", void 0);
exports.S3File = S3File = __decorate([
    (0, mongoose_1.Schema)({ _id: false })
], S3File);
let FileEmbedded = class FileEmbedded {
};
exports.FileEmbedded = FileEmbedded;
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: true }),
    __metadata("design:type", String)
], FileEmbedded.prototype, "id", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: false }),
    __metadata("design:type", String)
], FileEmbedded.prototype, "name", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: Number, required: true }),
    __metadata("design:type", Number)
], FileEmbedded.prototype, "size", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: String, required: true }),
    __metadata("design:type", String)
], FileEmbedded.prototype, "mimeType", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: S3, required: true, default: null }),
    __metadata("design:type", S3)
], FileEmbedded.prototype, "s3", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: Date, required: true }),
    __metadata("design:type", Date)
], FileEmbedded.prototype, "createdAt", void 0);
exports.FileEmbedded = FileEmbedded = __decorate([
    (0, mongoose_1.Schema)({ _id: false })
], FileEmbedded);
exports.S3Schema = mongoose_1.SchemaFactory.createForClass(S3);
exports.LogInitiatorSchema = mongoose_1.SchemaFactory.createForClass(LogInitiator);
exports.FileLogSchema = mongoose_1.SchemaFactory.createForClass(FileLog);
exports.FileMetaSchema = mongoose_1.SchemaFactory.createForClass(FileMeta);
exports.FileStateSchema = mongoose_1.SchemaFactory.createForClass(FileState);
exports.FileRecordSchema = mongoose_1.SchemaFactory.createForClass(FileRecord);
exports.S3FileSchema = mongoose_1.SchemaFactory.createForClass(S3File);
exports.FileEmbeddedSchema = mongoose_1.SchemaFactory.createForClass(FileEmbedded);
//# sourceMappingURL=s3.schema.js.map