import { HttpService } from '@nestjs/axios';
import { ConfigService } from '@nestjs/config';
import { RESTResult } from '../models/dtos/wrappers/rest-wrapper.class';
import { UserVerificationLevel } from '../models/enums/user-verifiation-level.enum';
import { UserType } from '../models/enums/user-type.enum';
import { IUser } from '../models/interfaces/user.interface';
export declare class IAMService {
    private readonly _httpService;
    private readonly _configService;
    private _baseUrl;
    constructor(_httpService: HttpService, _configService: ConfigService);
    list(firstName: string, lastName: string, types: UserType[], verificationLevels: UserVerificationLevel[]): Promise<RESTResult<IUser[]>>;
    read(id: string): Promise<RESTResult<IUser>>;
}
