"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IAMService = void 0;
const axios_1 = require("@nestjs/axios");
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const rest_wrapper_class_1 = require("../models/dtos/wrappers/rest-wrapper.class");
const rxjs_1 = require("rxjs");
let IAMService = class IAMService {
    constructor(_httpService, _configService) {
        this._httpService = _httpService;
        this._configService = _configService;
        this._baseUrl = this._configService.getOrThrow('DL_IAM__REST__BASE_URL');
    }
    async list(firstName, lastName, types, verificationLevels) {
        try {
            const queryParams = new URLSearchParams();
            if (firstName) {
                queryParams.append('firstName', firstName);
            }
            if (lastName) {
                queryParams.append('lastName', lastName);
            }
            if (types && types.length) {
                types.forEach((type) => queryParams.append('types', type));
            }
            if (verificationLevels && verificationLevels.length) {
                verificationLevels.forEach((level) => queryParams.append('verificationLevels', level));
            }
            const qs = queryParams.toString();
            const endpoint = `${this._baseUrl}/v1/users?${qs}`;
            const response$ = this._httpService.get(endpoint);
            const response = await (0, rxjs_1.firstValueFrom)(response$);
            if (response.data.errors) {
                throw new rest_wrapper_class_1.RESTError('iam_api_error', response.data.errors);
            }
            if (!response.data || !response.data.result) {
                throw new rest_wrapper_class_1.RESTError('iam_api_error', 'empty response');
            }
            return response.data.result;
        }
        catch (e) {
            throw rest_wrapper_class_1.RESTError.createFromCatch(e, { keyword: 'unknown', debug: e });
        }
    }
    async read(id) {
        try {
            const endpoint = `${this._baseUrl}/v1/users/${id}`;
            const response$ = this._httpService.get(endpoint);
            const response = await (0, rxjs_1.firstValueFrom)(response$);
            if (response.data.errors) {
                throw new rest_wrapper_class_1.RESTError('iam_api_error', response.data.errors);
            }
            if (!response.data || !response.data.result) {
                throw new rest_wrapper_class_1.RESTError('iam_api_error', 'empty response');
            }
            return response.data.result;
        }
        catch (e) {
            throw rest_wrapper_class_1.RESTError.createFromCatch(e, { keyword: 'unknown', debug: e });
        }
    }
};
exports.IAMService = IAMService;
exports.IAMService = IAMService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [axios_1.HttpService, config_1.ConfigService])
], IAMService);
//# sourceMappingURL=iam.service.js.map