import { ConfigService } from '@nestjs/config';
import { AxiosResponse } from 'axios';
import internal from 'stream';
import { IFileRequest } from '../models/interfaces/dl-storage.interface';
import { IS3File } from '../models/interfaces/s3.interface';
export declare class StorageService {
    private readonly _configsService;
    private readonly _storageApiUrl;
    private readonly _accessToken;
    private readonly _bucketName;
    constructor(_configsService: ConfigService);
    upload(body: IFileRequest, autoCommit: boolean): Promise<IS3File>;
    download(fileId: string): Promise<AxiosResponse<internal.PassThrough>>;
    getMeta(fileId: string, bucketName: string): Promise<IS3File>;
    private _handleAxiosResponse;
    private get _axiosStandardConfig();
    private get _axiosStreamConfig();
}
