import { HydratedDocument, Schema as MongooseSchema, Types } from 'mongoose';
import { IAuthor } from '../../interfaces/author.interface';
import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';

@Schema({ _id: false })
export class Author implements IAuthor {
    @Prop({ type: MongooseSchema.Types.ObjectId, default: null })
    userId: Types.ObjectId | string | null | undefined;

    @Prop({ type: String, required: false, default: null })
    pid: string | null | undefined;

    @Prop({ type: String, required: false, default: null })
    firstName: string | null | undefined;

    @Prop({ type: String, required: false, default: null })
    lastName: string | null | undefined;
}

export const AuthorSchema = SchemaFactory.createForClass(Author);
export type AuthorDocument = HydratedDocument<Author>;
