import { Schema, Prop, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { ICropArea } from '../../interfaces/crop-area.interface';

@Schema({ _id: false })
export class CropArea implements ICropArea {
    @Prop({ type: Number, required: true })
    x1: number;

    @Prop({ type: Number, required: true })
    x2: number;

    @Prop({ type: Number, required: true })
    y1: number;

    @Prop({ type: Number, required: true })
    y2: number;
}

export const CropAreaSchema = SchemaFactory.createForClass(CropArea);
export type CropAreaDocument = HydratedDocument<CropArea>;
