import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument, Schema as MongooseSchema, Types } from 'mongoose';
import { IDictionary } from '../../interfaces/dictionary.interface';
import { Base } from '../base.schema';
import { II18n } from '../../interfaces/i18n.interface';
import { I18nSchema } from './i18n.embedded';

@Schema()
export class DictionaryEmbedded extends Base implements IDictionary {
    @Prop({ type: [MongooseSchema.Types.ObjectId], required: true })
    parentIds: Types.ObjectId[];

    @Prop({ type: I18nSchema, required: true, default: null })
    title: II18n;

    @Prop({ type: Map, of: String, required: true, default: new Map() })
    metas: Map<string, string>;

    @Prop({ type: String, required: false, default: null })
    keyword: string;
}

export const DictionaryEmbeddedSchema = SchemaFactory.createForClass(DictionaryEmbedded);
export type DictionaryEmbeddedDocument = HydratedDocument<DictionaryEmbedded>;
