import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { Identifable } from '../identifable.schema';
import { IGroupSession, ITime } from '../../interfaces/group-session.interface';
import { WeekDay } from '../../enums/week-day.enum';
import { I18nSchema } from './i18n.embedded';
import { II18n } from '../../interfaces/i18n.interface';
import { Time } from './time.schema';

@Schema()
export class GroupSession extends Identifable implements IGroupSession {
    @Prop({ type: I18nSchema, required: false })
    description: II18n;

    @Prop({ type: Number, enum: WeekDay, required: true })
    day: WeekDay;

    @Prop({ type: Time, required: true })
    time: ITime;
}

export const GroupSessionSchema = SchemaFactory.createForClass(GroupSession);
export type GroupSessionDocument = HydratedDocument<GroupSession>;
