import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { II18n } from '../../interfaces/i18n.interface';

@Schema({ _id: false })
export class I18n implements II18n {
    @Prop({ type: String, required: false })
    ge: string;

    @Prop({ type: String, required: false })
    en: string;

    @Prop({ type: String, required: false })
    ua: string;
}

export const I18nSchema = SchemaFactory.createForClass(I18n);
export type I18nDocument = HydratedDocument<I18n>;
