import { Schema, Prop, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument } from 'mongoose';
import { IFileEmbedded } from '../../interfaces/s3.interface';
import { FileEmbeddedSchema } from './s3.schema';
import { IPicture } from '../../interfaces/picture.interface';
import { ICropArea } from '../../interfaces/crop-area.interface';
import { CropAreaSchema } from './crop-area.schema';

@Schema({ _id: false })
export class Picture implements IPicture {
    @Prop({ type: FileEmbeddedSchema, required: true, default: null })
    original: IFileEmbedded;

    @Prop({ type: FileEmbeddedSchema, required: false, default: null })
    cropped: IFileEmbedded | null | undefined;

    @Prop({ type: CropAreaSchema, required: false, default: null })
    cropArea: ICropArea | null | undefined;
}

export const PictureSchema = SchemaFactory.createForClass(Picture);
export type PictureDocument = HydratedDocument<Picture>;
