import { Prop, Schema, SchemaFactory } from '@nestjs/mongoose';
import { HydratedDocument, Schema as MongooseSchema, Types } from 'mongoose';
import { ITeacher } from '../../interfaces/teacher.interface';
import { IPerson } from '../../interfaces/person.interface';
import { PersonSchema } from './person.schema';

@Schema({ _id: false })
export class Teacher implements ITeacher {
    @Prop({ type: MongooseSchema.Types.ObjectId, required: true })
    userId: Types.ObjectId | string;

    @Prop({ type: PersonSchema, required: true })
    person: IPerson;
}

export const TeacherSchema = SchemaFactory.createForClass(Teacher);
export type TeacherDocument = HydratedDocument<Teacher>;
